<?php
/**
  * Novalnet payment method module
  * This module is used for real time processing of
  * Novalnet transaction of customers.
  *
  * Copyright (c) Novalnet AG
  *
  * Released under the GNU General Public License
  * This free contribution made by request.
  * If you have found this script useful a small
  * recommendation as well as a comment on merchant form
  * would be greatly appreciated.
  *
  * @file    : Novalnet Payment Module
  * Script   : uc_novalnet_page.inc
  *
  */

    define('UC_PAYMENT_TYPES' , serialize(array(
                'novalnet_invoice'     => array('INVOICE_CREDIT', 'INVOICE_START', 'SUBSCRIPTION_STOP'),
                'novalnet_prepayment'  => array('INVOICE_CREDIT', 'INVOICE_START', 'SUBSCRIPTION_STOP'),
                'novalnet_paypal'      => array('PAYPAL'),
                'novalnet_instantbank' => array('ONLINE_TRANSFER', 'REFUND_BY_BANK_TRANSFER_EU'),
                'novalnet_cc'          => array('CREDITCARD', 'CREDITCARD_BOOKBACK', 'CREDITCARD_CHARGEBACK', 'CREDIT_ENTRY_CREDITCARD', 'DEBT_COLLECTION_CREDITCARD', 'SUBSCRIPTION_STOP'),
                'novalnet_sepa'        => array('DIRECT_DEBIT_SEPA', 'RETURN_DEBIT_SEPA', 'SUBSCRIPTION_STOP', 'DEBT_COLLECTION_SEPA', 'CREDIT_ENTRY_SEPA'),
                'novalnet_ideal'       => array('IDEAL'),
                'novalnet_eps'         => array('EPS'),
                )));
    define('PAYMENT_TYPES' , serialize(array('INVOICE_CREDIT', 'INVOICE_START', 'PAYPAL', 'ONLINE_TRANSFER', 'CREDITCARD', 'CREDITCARD_BOOKBACK', 'IDEAL', 'DIRECT_DEBIT_SEPA', 'EPS')));
    define('INVOICE_ALLOWD' , serialize(array('INVOICE_CREDIT', 'INVOICE_START')));
    define('RECURRING_ALLOWD' , serialize(array('INVOICE_START', 'CREDITCARD', 'DIRECT_DEBIT_SEPA', 'SUBSCRIPTION_STOP')));
    define('CHARGE_BACK', serialize(array('CREDITCARD_CHARGEBACK', 'CREDITCARD_BOOKBACK', 'RETURN_DEBIT_SEPA', 'REFUND_BY_BANK_TRANSFER_EU')));
    define('NN_IP' , serialize(array('195.143.189.210', '195.143.189.214')));
    define('LINEBREAK', empty($_SERVER['HTTP_HOST']) ? PHP_EOL : '<br />');

/**
* callback script implementation : menu callback
* @params none
* @return none
*/
    function uc_novalnet_callbackscript() {
      $cbk_data = variable_get('novalnet_cbk_data');
      $url_request = array_map('check_plain', $_REQUEST);
      $url_request = array_map('trim', $_REQUEST);
      if (isset($url_request['debug_mode']) && $url_request['debug_mode'] == 1) {
         $cbk_data['test']  = TRUE;
         $cbk_data['debug'] = TRUE;
         $cbk_data['cbk_mail_from'] = 'testadmin@novalnet.de';
         $cbk_data['cbk_mail_to']   = 'test@novalnet.de';
         
      } 
      else {
         $cbk_data['test']  = (bool) $cbk_data['cbk_mail_test_mode'];
         $cbk_data['debug'] = (bool) $cbk_data['cbk_mail_debug'];     
      }
      if (check_ipaddr($cbk_data, $url_request)) {
        $order = '';
        if (check_params($cbk_data, $url_request, $order)) {
           set_order_status($url_request, $order, $cbk_data);
        }
      }
    }

/**
* callback script function : to check the Novalnet IP
* @params array $cbk_data
* @params request $url_request
* @return bool
*/
    function check_ipaddr(&$cbk_data, $url_request) {
      if ((!$cbk_data['debug'] && $cbk_data['test']) || in_array($_SERVER['REMOTE_ADDR'], unserialize(NN_IP))) {
        return FALSE;
      }
      if (!$cbk_data['test']) {
      echo t('Novalnet callback received') . ' ' . t('Unauthorised access from the IP [') . $_SERVER['REMOTE_ADDR'] . ']';
      return FALSE;
      }
      return TRUE;
    }

/**
* callback script function : to organise the  url params
* @params array $cbk_data
* @params array $url_request
* @params object $order
* @return bool
*/
    function check_params($cbk_data, &$url_request, &$order) { 
      if (empty($url_request)) {
        echo t('Novalnet callback received.') . ' ' . t('No params passed over!');
      }
      $required_params = array('vendor_id' => '', 'tid' => '', 'payment_type' => '', 'status' => '', 'amount' => '', 'tid_payment' => '', 'signup_tid' => '' );
      if ((isset($url_request['subs_billing']) && $url_request['subs_billing'] == 1 && (isset($url_request['payment_type']) && $url_request['payment_type'] != 'INVOICE_CREDIT')) || ((isset($url_request['payment_type']) && $url_request['payment_type'] == 'SUBSCRIPTION_STOP'))) {
         $url_request['cbk_type'] = 'recurring';
         unset($required_params['tid_payment']);
         unset($required_params['tid']);
      }
      else {
         $url_request['cbk_type'] = 'callback'; 
         unset($required_params['signup_tid']);
      }
      if (isset($url_request['payment_type']) && in_array($url_request['payment_type'], unserialize(CHARGE_BACK))) {
         unset($required_params['signup_tid']);
         $url_request['cbk_type'] = 'chargeback';
      }
      if (isset($url_request['vendor_activation']) && $url_request['vendor_activation']) {
         unset($required_params['signup_tid']);
         $url_request['cbk_type'] = 'affiliate';
      }
      switch ($url_request['cbk_type']) {
        case 'recurring':
               $url_request['org_tid'] = (isset($url_request['signup_tid']) && ($url_request['cbk_type'] == 'recurring')) ? $url_request['signup_tid'] :'';
               break;
        case 'callback':
               if (isset($url_request['payment_type']) && in_array($url_request['payment_type'], unserialize(INVOICE_ALLOWD)))
                 $url_request['org_tid'] = (isset($url_request['tid_payment'])) ? $url_request['tid_payment'] :'';
               else {
                 $url_request['org_tid'] = (isset($url_request['tid'])) ? $url_request['tid'] :'';
                 unset($required_params['tid_payment']);
               }
               break;
        case 'chargeback':
               $url_request['org_tid'] = (isset($url_request['tid_payment'])) ? $url_request['tid_payment']:'';
               break;
        case 'affiliate':           
               $required_params = array('vendor_id' => '', 'vendor_authcode' => '', 'product_id' => '', 'product_url' => '', 'activation_date' => '', 'aff_id' => '', 'aff_authcode' => '', 'aff_accesskey' => '');
               break;
      }
      $error_msg = '';
      foreach ($required_params as $key => $val) {
        if (empty($url_request[$key])) {
           $error_msg .= t('Novalnet callback received.') . ' ' . t('Required param missing!') . ' - ' . $key . LINEBREAK;
        }
        if (isset($url_request[$key]))
        $affiliate_params[$key] = $url_request[$key];
      }
      if (!empty($error_msg)) {
         if ($cbk_data['debug']) echo $error_msg;
         return FALSE;
      }
      if ($url_request['cbk_type'] == 'affiliate') { 
          $url_request = $affiliate_params; 
          $url_request['cbk_type'] = 'affiliate';
          return TRUE;
      }
      $order = validate_param($url_request, $required_params, $error_msg, $cbk_data); 
      if (!$order) {
         if ($cbk_data['debug']) echo $error_msg;
         return FALSE;
      } 
      else {
        if (!empty($_SESSION['nn']['nn_aff_id'])) unset($_SESSION['nn']['nn_aff_id']);
        $aff_details = nn_variable_get(array('customer_id' => $order->uid), 'nn_aff_user_detail');
        if (!empty($aff_details['aff_id'])) $_SESSION['nn']['nn_aff_id'] = $aff_details['aff_id'];   
      }
      return TRUE;
    }

/**
* callback script function : to validate url params
* @params array $required_params
* @params array $cbk_data
* @params array $url_request
* @params string $error_msg
* @return mixed
*/
    function validate_param($url_request, $required_params, &$error_msg, $cbk_data) {
      $tid_arry = array('tid', 'signup_tid', 'tid_payment');
      foreach ($tid_arry as $key) {
        if (isset($required_params[$key])) { 
           if (strlen($url_request[$key]) != 17 || preg_match('/^[^0-9]$/' , $url_request[$key])) {
               $error_msg .= t('Novalnet callback received.') . ' ' . t('Invalid') . ucwords($key) . ' - ' . $url_request[$key] . LINEBREAK;
            }
        }
      }
      if (!empty($error_msg)) return FALSE;
      if (!preg_match('!^[1-9][0-9]*$!', $url_request['amount'])) {
         $error_msg .= t('Novalnet callback received.') . ' ' . t('Order amount should be greater than zero') . LINEBREAK;
         return FALSE;
      } 
      $transdetails = get_orginal_details($url_request['org_tid']);
      uc_novalnet_save_log($transdetails->order_id , $url_request, 'callback');
      if (!empty($url_request['order_no']) && !empty($transdetails) && $transdetails->order_id != $url_request['order_no']) {
         $error_msg .= 'Novalnet callback received. Order no is not valid!.' . LINEBREAK;
         return FALSE; 
      }
      
      $order = uc_order_load($transdetails->order_id);
      $paymenttypes = unserialize(UC_PAYMENT_TYPES);
      if (!in_array($url_request['payment_type'], $paymenttypes[$order->payment_method])) {
         $error_msg .= t('Novalnet callback received.') . ' ' . t('Payment type Mismatched!') . LINEBREAK;
         return FALSE;
      }
      return $order;
    }

/**
* callback script function : to differentiate the callback types
* @params array $url_request
* @params object $order
* @params array $cbk_data
* @return bool
*/
    function set_order_status($url_request, $order, $cbk_data) { 
        $messages = array('error' => '', 'mail_body' => '', 'comment' => '');
        if ($url_request['cbk_type'] == 'affiliate') activate_affiliate($url_request, $messages);
        else {
            $currency = $order->currency;
            $amount   = sprintf('%0.2f', $url_request['amount']/100) . ' ' . $currency; 
            if ($url_request['status'] == 100 || $url_request['cbk_type'] == 'affiliate') {  
              switch ($url_request['cbk_type']) { 
                case 'recurring': 
                   recurring_update($order, $url_request, $messages);
                   break;
                case 'callback':
                   callback_update($order, $url_request, $messages, $amount);
                   break;
                case 'chargeback':
                  chargeback_update($order, $url_request, $messages, $amount);
                  break;
              }
            }
            else{ 
                $messages['error'] .= t('Novalnet callback received.') . ' ' . t('Order - got completed already. Refer Order :') . $order->order_id . LINEBREAK;
            }
        }
        if (!empty($messages['error'])) {
            if ($cbk_data['debug']) echo $messages['error'];
            return FALSE;
        }
        if (!empty($messages['mail_body']) && $cbk_data['cbk_mail_send'] == 1) { 
            uc_novalnet_cbk_mail($cbk_data, $messages);
            watchdog('Novalnet Callbackscript', $messages['mail_body']); 
        }
        elseif ($cbk_data['debug'] && $cbk_data['cbk_mail_send'] != 1) {
            echo t('Mail sending failed (Please configure the callbackscript )') . $messages['mail_body'] . (isset($messages['mail_msg']) ? $messages['mail_msg'] : '' );
        }
    }

/**
* callback script function : to activate affiliate process
* @params array $affiliate_params
* @params array $messages
* @return none
*/
 
    function activate_affiliate($affiliate_params, &$messages) {
        unset($affiliate_params['cbk_type']);
        update_variable($id = '', $affiliate_params, 'nn_aff_account_detail');
        $messages['error'] .= LINEBREAK . 'Novalnet callback script executed successfully with Novalnet account activation information.' . LINEBREAK;
    }
    
/**
* callback script function : to update the order status
* @params object $order
* @params array $url_request
* @params array $messages
* @params string $amount
* @return bool
*/
    function callback_update($order, $url_request, &$messages, $amount) {
      if ($url_request['payment_type'] == 'SUBSCRIPTION_STOP') {
         $messages['error'] .= t('Novalnet callback received.') . ' ' . t('Payment type Mismatched!') . LINEBREAK;
         return FALSE;
      } 
      $tid_details   = nn_variable_get(array('order_id' => $order->order_id), 'uc_novalnet_transaction'); 
      $order_balance = $tid_details['amount'];
      
      $msg = '';

      if (($url_request['payment_type'] == 'INVOICE_CREDIT' && $order_balance > 0)) {
         $messages['comment'] = t('Novalnet Callback Script executed successfully for the TID:') . ' ' . $url_request['tid_payment'] . ' ' . t('with amount') . ' ' . $amount . ' ' . t('on') . ' ' . date('d.m.Y H:i:s') . '. ' . t('Please refer PAID transaction in our Novalnet Merchant Administration with the TID:') . ' ' . $url_request['tid'] . LINEBREAK;
        $comment = $messages['comment'];
        $amt = isset($tid_details['callback_amount']) ? $tid_details['callback_amount'] + $url_request['amount'] : $url_request['amount'];
        update_variable(array('order_id' => $order->order_id), array('callback_amount' => $amt), 'uc_novalnet_transaction');
        db_update('uc_novalnet_transaction') 
                ->fields(array('callback_total' => $amt ))
                ->expression('callback_total', 'callback_total + :amount', array(':amount' => $url_request['amount']))
                ->condition('order_id', $order->order_id, '=')
                ->execute(); 
        $order_state   = $order->order_status; 
        $order_bal = $order_balance - $url_request['amount']; 
        if ($order_bal <= 0) {
        $order_state   =  variable_get($order->payment_method . '_after_status', 'completed');    
        update_variable(array('order_id' => $order->order_id), array('amount' => $order_balance), 'uc_novalnet_transaction'); 
        }

        if ($order_bal < 0) 
        $msg = LINEBREAK . t('Paid amount is greater than the order amount.');            
     } 
     elseif (!in_array($url_request['payment_type'], unserialize(INVOICE_ALLOWD)) && uc_payment_balance($order) > 0 ) {
         $messages['comment'] = t('Novalnet Callback Script executed successfully for the TID:') . ' ' . $url_request['tid'] . ' ' . t('with amount') . ' ' . $order_balance . ' ' . t('on') . ' ' . date('d.m.Y H:i:s') . LINEBREAK;
         $comment = $messages['comment'];
         if ($url_request['payment_type'] == 'PAYPAL')
         $order_state   = variable_get($order->payment_method . '_after_status', 'completed');
     }     
     else { 
         $order_payments = array('novalnet_prepayment', 'novalnet_paypal', 'novalnet_invoice');
         if (in_array($order->payment_method, $order_payments))
         echo 'Novalnet callbackscript received. Order already paid!';
         else
         echo 'Novalnet callbackscript received. Payment type ( ' . $url_request['payment_type'] . ' ) is not applicable for this process!';
         return FALSE;
     }
     
     $messages['mail_body'] = $messages['comment'];
     $messages['mail_msg']  = $msg;

     update_variable(array('order_id' => $order->order_id), array('amount' => $order_bal), 'uc_novalnet_transaction'); 
     uc_order_comment_save($order->order_id,  0,  $comment ,  'order',  $order_state, 'TRUE');
     uc_payment_enter($order->order_id, $order->payment_method, ($url_request['amount']/100),  $order->uid,  NULL, $messages['mail_body']);
     uc_order_update_status($order->order_id, $order_state);
    }

/**
* callback script function : to update the recurring process
* @params object $order
* @params array $url_request
* @params array $messages
* @return bool
*/    
    function recurring_update($order, $url_request, &$messages) {  
        global $base_url; $basic_data = basic_params(); 
        
        if (!in_array($url_request['payment_type'], unserialize(RECURRING_ALLOWD))) {
            $messages['error'] .= LINEBREAK . t('Novalnet callback received.') . ' ' . t('Payment type Mismatched!');
            return FALSE;
        }
        
        if ($url_request['payment_type'] == 'SUBSCRIPTION_STOP') { 
             $termination_reason = (isset($url_request['termination_reason']) && !empty($url_request['termination_reason'])) ? $url_request['termination_reason'] : t("other");
             $messages['mail_body'] .= LINEBREAK . LINEBREAK . t('Novalnet callback received.') . ' ' . t('Subscription has been canceled for the Order no :') . ' ' . $order->order_id . ' ' . t("on") . ' ' . date("d.m.Y") . LINEBREAK . t('Reason for cancellation') . ' : ' . $termination_reason; 
             subscription_cancel_update($order->order_id, $messages['mail_body'], $termination_reason);          
             return TRUE;
        }
        $xmlresponse = uc_novalnet_update_status($data = array(), $url_request['signup_tid']);
        if (empty($xmlresponse['next_subs_cycle'])) {
            $messages['error'] .= LINEBREAK . t('Novalnet callback received.') . ' ' . t('Subscription has been canceled for the Order no :') . $order->order_id; 
            return FALSE;
        } 
        else {
            $cancel_table['order_id'] = $order->order_id;
            $cancel_table['tid']      = $url_request['tid'];
            $order_status             = $order->order_status;
            $order = create_order($order);
            $url_request['payment_method'] = $order->payment_method;
            if (in_array($url_request['payment_method'], array('novalnet_invoice', 'novalnet_prepayment'))) {
            $url_request['invoice_det']  = TRUE;
            $bank_details = array('invoice_iban', 'invoice_bic', 'invoice_bankname',  'invoice_bankplace', 'due_date');
            foreach ($bank_details as $val) {
                $bank_det[$val] = $url_request[$val];
            }
            if (count($bank_det) != count(array_filter($bank_det)))
                $url_request['invoice_det'] = FALSE;            
            }
            $messages['mail_body'] = uc_novalnet_get_comments($url_request, $order) . LINEBREAK;
            $messages['mail_body'] .= t('Next Charging Date :') . " " . date('d.m.Y H:i:s' , strtotime($xmlresponse['next_subs_cycle'])) . LINEBREAK;
            $cancel_table['ref_orders'] = $order->order_id; 
            update_variable(array(), $cancel_table, 'uc_novalnet_cancel');
            $amt = ($url_request['amount']/100);
            if ($url_request['payment_type'] == 'INVOICE_START') {
            $order_status = variable_get($order->payment_method . '_before_status', 'pending');
            $amt = 0;
            }
            else {
            $order_status = variable_get($order->payment_method . '_after_status', 'completed');
            }
            uc_order_comment_save($order->order_id, 0, $messages['mail_body'], 'order', $order_status, 'TRUE');
            uc_payment_enter($order->order_id, $order->payment_method, $amt,  $order->uid,  NULL, $messages['mail_body']);
            uc_order_update_status($order->order_id, $order_status);
            $key = uc_novalnet_payment_methods($order->payment_method);
            $update_data = array(
              'tid'           => $url_request['tid'],
              'status'        => $xmlresponse['status'],
              'key'           => $key['key'],
              'amount'        => $url_request['amount'],
              'subscription'  => $url_request['signup_tid'],
            );
            $basic_array = array('vendor_id', 'auth_code', 'product_id', 'tariff_id');
            foreach ($basic_array as $key) {
                $update_data[$key] = $basic_data[$key];
            } 
            update_variable(array('order_id' => $order->order_id), $update_data, 'uc_novalnet_transaction');
        }
    }
    
/**
* callback script function : to update the chargeback process
* @params object $order
* @params array $url_request
* @params array $messages
* @params string $amount
* @return none
*/
    function chargeback_update($order, $url_request, &$messages, $amount) {
      $messages['mail_body'] .= LINEBREAK . t('Novalnet callback received.') . ' ' . t('Chargeback was executed successfully TID :') . $url_request['org_tid'] . ' ' . "with amount" . ' ' . $amount . ' ' . t("on") . ' ' . date('d.m.Y H:i:s') . LINEBREAK . t('Please refer PAID transaction in our Novalnet Merchant Administration with the TID:') . ' ' . $url_request['tid'] . LINEBREAK;
      uc_order_comment_save($order->order_id,  0,  $messages['mail_body'] ,  'order',  $order->order_status, 'TRUE');
    }
    
    function uc_novalnet_cbk_mail($cbk_data, $messages) { 
        $messages['mail_msg'] = isset($messages['mail_msg']) ? $messages['mail_msg'] : '';
        global $language;
        if (empty($cbk_data['debug'])) $cbk_data['cbk_mail_body'] .= LINEBREAK . LINEBREAK . LINEBREAK ;
        $cbk_data['cbk_mail_body'] .= t('Novalnet Callback script Details  as follows') . LINEBREAK . $messages['mail_body'];
        $params['subject'] = $cbk_data['cbk_mail_subject'];
        $params['body'] = t('Dear Customer,') . LINEBREAK . LINEBREAK . $cbk_data['cbk_mail_body'] . LINEBREAK . LINEBREAK . t('Regards,') . LINEBREAK . 'Novalnet AG';
        $params['headers'] = array(
            'Bcc' => $cbk_data['cbk_mail_bcc'], 
        );
        $mailreslt = drupal_mail('uc_novalnet', 'nn_callback', $cbk_data['cbk_mail_to'], $language -> language, $params, $cbk_data['cbk_mail_from'], TRUE); 
        if ($cbk_data['debug'] || $mailreslt['result'] == 1) echo '<meta content="text/html; charset=utf-8" http-equiv="Content-Type">' . t('Sending Email succeeded!') . LINEBREAK . LINEBREAK . $cbk_data['cbk_mail_body'] . LINEBREAK . $messages['mail_msg'];
    } 

/**
* callback script function : new order generation after the recurring runs
* @params object $old_order
* @return object $order
*/    
    function create_order($old_order) { 
        $node_id = end($old_order->products); 
        $productnode = node_load($node_id->nid); 
        $product = db_select('uc_products', 'c')->fields('c')->condition('vid', $productnode->vid)->execute()->fetchAll();
        $product = $product[0]; 
        $product->qty       = $old_order->product_count;
        $product->title     = $productnode->title;
        $product->nid       = $productnode->nid;
        $product->price     = $productnode->sell_price;
        $product->data['shippable'] = $product->shippable;

        $order = uc_order_new($old_order->uid, $old_order->order_status);
        $order_det = array('delivery_first_name', 'delivery_last_name', 'delivery_phone', 'delivery_company', 'delivery_street1', 'delivery_street2', 'delivery_city', 'delivery_zone', 'delivery_postal_code', 'delivery_country', 'primary_email', 'billing_first_name', 'billing_last_name', 'billing_company', 'billing_phone', 'billing_city', 'billing_street1', 'billing_street2', 'billing_postal_code', 'billing_zone', 'billing_country');
        foreach ($order_det as $val) {
            $order->$val = $old_order->$val;
        }
        for ($i = 0; $i <= $old_order->product_count; $i++) {
           $order->products[] = $product;
        }       
        $order->payment_method = $old_order->payment_method;
        foreach ($old_order->line_items as $item) {
            if ($item['type'] != 'subtotal')
            $order->line_items[] = uc_order_line_item_add($order->order_id, $item['type'], $item['title'], $item['amount']);
        }
        uc_order_save($order);
        $order = uc_order_load($order->order_id);
        return $order;
    }
