<?php
/**
  * Novalnet payment method module
  * This module is used for real time processing of
  * Novalnet transaction of customers.
  *
  * Copyright (c) Novalnet AG
  *
  * Released under the GNU General Public License
  * This free contribution made by request.
  * If you have found this script useful a small
  * recommendation as well as a comment on merchant form
  * would be greatly appreciated.
  *
  * @file    : Novalnet Payment Module
  * Script   : uc_novalnet.views_default.inc
  *
  */

function uc_novalnet_views_default_views() {
    $view = new view;
    $view->name = 'uc_novalnet';
    $view->description = '';
    $view->tag = 'Ubercart Novalnet Orders';
    $view->base_table = 'uc_orders';
    $view->human_name = 'uc_novalnet_order';
    $view->core = 0;
    $view->api_version = '3.0';
    $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

    /* Display: Defaults */
    $handler = $view->new_display('default', 'Defaults', 'default');
    $handler->display->display_options['title'] = 'Novalnet Orders';
    $handler->display->display_options['access']['type'] = 'none';
    $handler->display->display_options['cache']['type'] = 'none';
    $handler->display->display_options['query']['type'] = 'views_query';
    $handler->display->display_options['query']['options']['query_comment'] = FALSE;
    $handler->display->display_options['exposed_form']['type'] = 'basic';
    $handler->display->display_options['pager']['type'] = 'full';
    $handler->display->display_options['pager']['options']['items_per_page'] = '30';
    $handler->display->display_options['pager']['options']['offset'] = '0';
    $handler->display->display_options['pager']['options']['id'] = '0';
    $handler->display->display_options['style_plugin'] = 'table';
    $handler->display->display_options['style_options']['columns'] = array(
      'actions' => 'actions',
      'order_id' => 'order_id',
      'billing_full_name' => 'billing_full_name',
      'order_status' => 'order_status',
      'created' => 'created',
      'order_total' => 'order_total',
    );
    $handler->display->display_options['style_options']['default'] = 'order_id';
    $handler->display->display_options['style_options']['info'] = array(
      'actions' => array(
        'align' => '',
        'separator' => '',
      ),
      'order_id' => array(
        'sortable' => 1,
        'align' => '',
        'separator' => '',
      ),
      'billing_full_name' => array(
        'align' => '',
        'separator' => '',
      ),
      'order_status' => array(
        'sortable' => 1,
        'align' => '',
        'separator' => '',
      ),
      'created' => array(
        'sortable' => 1,
        'align' => '',
        'separator' => '',
      ),
      'order_total' => array(
        'sortable' => 1,
        'align' => '',
        'separator' => '',
      ),
    );
    $handler->display->display_options['style_options']['sticky'] = TRUE;
    $handler->display->display_options['style_options']['order'] = 'desc';
    /* Field: Order: Actions */
    $handler->display->display_options['fields']['actions']['id'] = 'actions';
    $handler->display->display_options['fields']['actions']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['actions']['field'] = 'actions';
    /* Field: Order: Order ID */
    $handler->display->display_options['fields']['order_id']['id'] = 'order_id';
    $handler->display->display_options['fields']['order_id']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['order_id']['field'] = 'order_id';
    $handler->display->display_options['fields']['order_id']['link_to_order'] = 1;
    /* Field: User: Uid */
    $handler->display->display_options['fields']['uid']['id'] = 'uid';
    $handler->display->display_options['fields']['uid']['table'] = 'users';
    $handler->display->display_options['fields']['uid']['field'] = 'uid';
    $handler->display->display_options['fields']['uid']['label'] = '';
    $handler->display->display_options['fields']['uid']['exclude'] = TRUE;
    $handler->display->display_options['fields']['uid']['alter']['text'] = '[billing_full_name]';
    $handler->display->display_options['fields']['uid']['alter']['path'] = '[uid]';
    $handler->display->display_options['fields']['uid']['element_label_colon'] = FALSE;
    $handler->display->display_options['fields']['uid']['link_to_user'] = FALSE;
    /* Field: Order: Billing address: Full name */
    $handler->display->display_options['fields']['billing_full_name']['id'] = 'billing_full_name';
    $handler->display->display_options['fields']['billing_full_name']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['billing_full_name']['field'] = 'billing_full_name';
    $handler->display->display_options['fields']['billing_full_name']['label'] = 'Customer';
    $handler->display->display_options['fields']['billing_full_name']['alter']['make_link'] = TRUE;
    $handler->display->display_options['fields']['billing_full_name']['alter']['path'] = 'user/[uid]';
    /* Field: Order: Order total */
    $handler->display->display_options['fields']['order_total']['id'] = 'order_total';
    $handler->display->display_options['fields']['order_total']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['order_total']['field'] = 'order_total';
    $handler->display->display_options['fields']['order_total']['label'] = 'Total';
    $handler->display->display_options['fields']['order_total']['hide_alter_empty'] = FALSE;
    $handler->display->display_options['fields']['order_total']['precision'] = '0';
    /* Field: Order: Creation date */
    $handler->display->display_options['fields']['created']['id'] = 'created';
    $handler->display->display_options['fields']['created']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['created']['field'] = 'created';
    $handler->display->display_options['fields']['created']['label'] = 'Purchase date';
    $handler->display->display_options['fields']['created']['hide_alter_empty'] = FALSE;
    $handler->display->display_options['fields']['created']['date_format'] = 'uc_store';
    /* Field: Order: Order status */
    $handler->display->display_options['fields']['order_status']['id'] = 'order_status';
    $handler->display->display_options['fields']['order_status']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['order_status']['field'] = 'order_status';
    $handler->display->display_options['fields']['order_status']['label'] = 'Status';
    $handler->display->display_options['fields']['order_status']['hide_alter_empty'] = FALSE;
    /* Field: Order: Payment method */
    $handler->display->display_options['fields']['payment_method']['id'] = 'payment_method';
    $handler->display->display_options['fields']['payment_method']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['payment_method']['field'] = 'payment_method';
    $handler->display->display_options['fields']['payment_method']['label'] = 'Payment Method';
    /* Filter criterion: Order: Order ID */
    $handler->display->display_options['filters']['order_id']['id'] = 'order_id';
    $handler->display->display_options['filters']['order_id']['table'] = 'uc_orders';
    $handler->display->display_options['filters']['order_id']['field'] = 'order_id';
    $handler->display->display_options['filters']['order_id']['group'] = 0;
    $handler->display->display_options['filters']['order_id']['exposed'] = TRUE;
    $handler->display->display_options['filters']['order_id']['expose']['operator_id'] = 'order_id_op';
    $handler->display->display_options['filters']['order_id']['expose']['label'] = 'View order number';
    $handler->display->display_options['filters']['order_id']['expose']['operator'] = 'order_id_op';
    $handler->display->display_options['filters']['order_id']['expose']['identifier'] = 'order_id';
    /* Filter criterion: Order: Order status */
    $handler->display->display_options['filters']['order_status']['id'] = 'order_status';
    $handler->display->display_options['filters']['order_status']['table'] = 'uc_orders';
    $handler->display->display_options['filters']['order_status']['field'] = 'order_status';
    $handler->display->display_options['filters']['order_status']['value'] = array(
      '_active' => '_active',
      'abandoned' => 'abandoned',
      'canceled' => 'canceled',
      'pending' => 'pending',
      'processing' => 'processing',
      'payment_received' => 'payment_received',
      'completed' => 'completed',
    );
    $handler->display->display_options['filters']['order_status']['group'] = 0;
    $handler->display->display_options['filters']['order_status']['exposed'] = TRUE;
    $handler->display->display_options['filters']['order_status']['expose']['operator_id'] = 'order_status_op';
    $handler->display->display_options['filters']['order_status']['expose']['label'] = 'View by status';
    $handler->display->display_options['filters']['order_status']['expose']['operator'] = 'order_status_op';
    $handler->display->display_options['filters']['order_status']['expose']['identifier'] = 'order_status';
    $handler->display->display_options['filters']['order_status']['expose']['reduce'] = 0;
    /* Filter criterion: Order: Payment method */
    $handler->display->display_options['filters']['payment_method']['id'] = 'payment_method';
    $handler->display->display_options['filters']['payment_method']['table'] = 'uc_orders';
    $handler->display->display_options['filters']['payment_method']['field'] = 'payment_method';
    $handler->display->display_options['filters']['payment_method']['value'] = array(
      'novalnet_sepa' => 'novalnet_sepa',
      'novalnet_paypal' => 'novalnet_paypal',
      'novalnet_instantbank' => 'novalnet_instantbank',
      'novalnet_ideal' => 'novalnet_ideal',
      'novalnet_prepayment' => 'novalnet_prepayment',
      'novalnet_invoice' => 'novalnet_invoice',
      'novalnet_cc' => 'novalnet_cc',
    );

    /* Display: Admin page */
    $handler = $view->new_display('page', 'Admin page', 'admin_page');
    $handler->display->display_options['defaults']['fields'] = FALSE;
    /* Field: Order: Actions */
    $handler->display->display_options['fields']['actions']['id'] = 'actions';
    $handler->display->display_options['fields']['actions']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['actions']['field'] = 'actions';
    /* Field: Order: Order ID */
    $handler->display->display_options['fields']['order_id']['id'] = 'order_id';
    $handler->display->display_options['fields']['order_id']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['order_id']['field'] = 'order_id';
    $handler->display->display_options['fields']['order_id']['link_to_order'] = 1;
    /* Field: User: Uid */
    $handler->display->display_options['fields']['uid']['id'] = 'uid';
    $handler->display->display_options['fields']['uid']['table'] = 'users';
    $handler->display->display_options['fields']['uid']['field'] = 'uid';
    $handler->display->display_options['fields']['uid']['label'] = '';
    $handler->display->display_options['fields']['uid']['exclude'] = TRUE;
    $handler->display->display_options['fields']['uid']['alter']['text'] = '[billing_full_name]';
    $handler->display->display_options['fields']['uid']['alter']['path'] = '[uid]';
    $handler->display->display_options['fields']['uid']['element_label_colon'] = FALSE;
    $handler->display->display_options['fields']['uid']['link_to_user'] = FALSE;
    /* Field: Order: Billing address: Full name */
    $handler->display->display_options['fields']['billing_full_name']['id'] = 'billing_full_name';
    $handler->display->display_options['fields']['billing_full_name']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['billing_full_name']['field'] = 'billing_full_name';
    $handler->display->display_options['fields']['billing_full_name']['label'] = 'Customer';
    $handler->display->display_options['fields']['billing_full_name']['alter']['make_link'] = TRUE;
    $handler->display->display_options['fields']['billing_full_name']['alter']['path'] = 'user/[uid]';
    /* Field: Order: Order total */
    $handler->display->display_options['fields']['order_total']['id'] = 'order_total';
    $handler->display->display_options['fields']['order_total']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['order_total']['field'] = 'order_total';
    $handler->display->display_options['fields']['order_total']['label'] = 'Total';
    $handler->display->display_options['fields']['order_total']['hide_alter_empty'] = FALSE;
    $handler->display->display_options['fields']['order_total']['precision'] = '0';
    /* Field: Order: Creation date */
    $handler->display->display_options['fields']['created']['id'] = 'created';
    $handler->display->display_options['fields']['created']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['created']['field'] = 'created';
    $handler->display->display_options['fields']['created']['label'] = 'Purchase date';
    $handler->display->display_options['fields']['created']['hide_alter_empty'] = FALSE;
    $handler->display->display_options['fields']['created']['date_format'] = 'uc_store';
    /* Field: Order: Order status */
    $handler->display->display_options['fields']['order_status']['id'] = 'order_status';
    $handler->display->display_options['fields']['order_status']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['order_status']['field'] = 'order_status';
    $handler->display->display_options['fields']['order_status']['label'] = 'Status';
    $handler->display->display_options['fields']['order_status']['hide_alter_empty'] = FALSE;
    /* Field: Order: Payment method */
    $handler->display->display_options['fields']['payment_method']['id'] = 'payment_method';
    $handler->display->display_options['fields']['payment_method']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['payment_method']['field'] = 'payment_method';
    $handler->display->display_options['fields']['payment_method']['label'] = 'Payment Method';
    /* Field: Order: Actions */
    $handler->display->display_options['fields']['actions_1']['id'] = 'actions_1';
    $handler->display->display_options['fields']['actions_1']['table'] = 'uc_orders';
    $handler->display->display_options['fields']['actions_1']['field'] = 'actions';
    $handler->display->display_options['fields']['actions_1']['alter']['alter_text'] = 1;
    $handler->display->display_options['fields']['actions_1']['alter']['text'] = 'Logs';
    $handler->display->display_options['fields']['actions_1']['alter']['make_link'] = 1;
    $handler->display->display_options['fields']['actions_1']['alter']['path'] = 'admin/novalnet/novalnet_orders/[order_id]/novalnet_log';
    $handler->display->display_options['fields']['actions_1']['alter']['absolute'] = 0;
    $handler->display->display_options['fields']['actions_1']['alter']['external'] = 0;
    $handler->display->display_options['fields']['actions_1']['alter']['replace_spaces'] = 0;
    $handler->display->display_options['fields']['actions_1']['alter']['trim_whitespace'] = 0;
    $handler->display->display_options['fields']['actions_1']['alter']['nl2br'] = 0;
    $handler->display->display_options['fields']['actions_1']['alter']['word_boundary'] = 1;
    $handler->display->display_options['fields']['actions_1']['alter']['ellipsis'] = 1;
    $handler->display->display_options['fields']['actions_1']['alter']['strip_tags'] = 0;
    $handler->display->display_options['fields']['actions_1']['alter']['trim'] = 0;
    $handler->display->display_options['fields']['actions_1']['alter']['html'] = 0;
    $handler->display->display_options['fields']['actions_1']['element_label_colon'] = 1;
    $handler->display->display_options['fields']['actions_1']['element_default_classes'] = 1;
    $handler->display->display_options['fields']['actions_1']['hide_empty'] = 0;
    $handler->display->display_options['fields']['actions_1']['empty_zero'] = 0;
    $handler->display->display_options['fields']['actions_1']['hide_alter_empty'] = 1;
    $handler->display->display_options['path'] = 'admin/novalnet/novalnet_orders';
    $handler->display->display_options['menu']['type'] = 'normal';
    $handler->display->display_options['menu']['title'] = 'Novalnet orders';
    $handler->display->display_options['menu']['description'] = '';
    $handler->display->display_options['menu']['weight'] = '';
    $handler->display->display_options['menu']['name'] = 'management';
    $translatables['uc_novalnet'] = array(
      t('Defaults'),
      t('Novalnet Orders'),
      t('more'),
      t('Apply'),
      t('Reset'),
      t('Sort by'),
      t('Asc'),
      t('Desc'),
      t('Items per page'),
      t('- All -'),
      t('Offset'),
      t('Actions'),
      t('Order ID'),
      t('[billing_full_name]'),
      t('[uid]'),
      t('Customer'),
      t('user/[uid]'),
      t('Total'),
      t('.'),
      t(','),
      t('Purchase date'),
      t('Status'),
      t('Payment Method'),
      t('View order number'),
      t('View by status'),
      t('Admin page'),
      t('Logs'),
      t('admin/novalnet/novalnet_orders/[order_id]/novalnet_log'),
    );
    $views[$view->name] = $view;
    return $views;
}
